/**
---------------------------------------------------------------------------

 PMango Project

 Title:      add or edit group information

 File:       addedit.js
 Location:   pmango\modules\groups
 Started:    2005.09.30
 Author:     Lorenzo Ballini
 Type:       Javascript

 This file is part of the PMango project
 Further information at: http://penelope.di.unipi.it

 Version history.
 - 2006.07.26 Lorenzo
   Second version, modified to manage PMango groups.
 - 2006.07.26 Lorenzo
   First version, unmodified from dotProject 2.0.1.
   
---------------------------------------------------------------------------

 PMango - A web application for project planning and control.

 Copyright (C) 2006 Giovanni A. Cignoni, Lorenzo Ballini, Marco Bonacchi
 All rights reserved.

 PMango reuses part of the code of dotProject 2.0.1: dotProject code is 
 released under GNU GPL, further information at: http://www.dotproject.net
 Copyright (c) 2003-2005 The dotProject Development Team

 Other libraries used by PMango are redistributed under their own license.
 See ReadMe.txt in the root folder for details. 

 PMango is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation Inc., 51 Franklin St, 5th Floor, Boston, MA 02110-1301 USA

---------------------------------------------------------------------------
*/
function addSetcap(form) { 
	var fl = form.setcap.length -1;
	var au = form.assignedsc.length -1;

	var users = "x";

	//build array of assiged users
	for (au; au > -1; au--) {
		users = users + "," + form.assignedsc.options[au].value + ","
	}

	//Pull selected setcap and add them to list
	for (fl; fl > -1; fl--) {
		if (form.setcap.options[fl].selected && users.indexOf( "," + form.setcap.options[fl].value + "," ) == -1) {
			t = form.assignedsc.length
			opt = new Option( form.setcap.options[fl].text, form.setcap.options[fl].value);
			form.group_setcap.value += form.setcap.options[fl].value+";";
			form.assignedsc.options[t] = opt
		}
	}
	
	
}

function removeSetcap(form) {
	fl = form.assignedsc.length -1;
	for (fl; fl > -1; fl--) {
		if (form.assignedsc.options[fl].selected) {
			//remove from members
			var selValue = form.assignedsc.options[fl].value;			
			var re = ".*("+selValue+";).*";
			var hiddenValue = form.group_setcap.value;
			if (hiddenValue) {	
				var b = hiddenValue.match(re);
				if (b[1]) {
					hiddenValue = hiddenValue.replace(b[1], '');
				}
				form.group_setcap.value = hiddenValue;
				form.assignedsc.options[fl] = null;
			}
		}
	}
}


function addUser(form) { 
	var fl = form.resources.length -1;
	var au = form.assigned.length -1;

	var users = "x";

	//build array of assiged users
	for (au; au > -1; au--) {
		users = users + "," + form.assigned.options[au].value + ","
	}

	//Pull selected resources and add them to list
	for (fl; fl > -1; fl--) {
		if (form.resources.options[fl].selected && users.indexOf( "," + form.resources.options[fl].value + "," ) == -1) {
			t = form.assigned.length
			opt = new Option( form.resources.options[fl].text, form.resources.options[fl].value);
			form.group_members.value += form.resources.options[fl].value+";";
			form.assigned.options[t] = opt
		}
	}
	
	
}

function removeUser(form) {
	fl = form.assigned.length -1;
	for (fl; fl > -1; fl--) {
		if (form.assigned.options[fl].selected) {
			//remove from members
			var selValue = form.assigned.options[fl].value;			
			var re = ".*("+selValue+";).*";
			var hiddenValue = form.group_members.value;
			if (hiddenValue) {	
				var b = hiddenValue.match(re);
				if (b[1]) {
					hiddenValue = hiddenValue.replace(b[1], '');
				}
				form.group_members.value = hiddenValue;
				form.assigned.options[fl] = null;
			}
		}
	}
}

//If None has been selected, remove the existing entries.
function clearExceptFor(obj, id){
	var td = obj.length -1;
	for (td; td > -1; td--) {
		if(obj.options[td].value != id){
			obj.options[td]=null;
		}
	}
}

/**
* no comment needed
*/
function isInArray(myArray, intValue) {

	for (var i = 0; i < myArray.length; i++) {
		if (myArray[i] == intValue) {
			return true;
		}
	}		
	return false;
}




